package videostore;

// 10.5
public class Film {
    public static final int BAMBINI = 2;
    public static final int REGOLARE = 0;
    public static final int NOVITA = 1;
    
    private String _titolo;
    private int _codicePrezzo;
    private Prezzo _prezzo;

    public Film(String titolo, int codicePrezzo) {
	_titolo = titolo;
	setCodicePrezzo(codicePrezzo);
    }

    public int getCodicePrezzo() {
	return _prezzo.getCodicePrezzo();
    }

    public void setCodicePrezzo(int arg) {
	switch (arg) {
	case REGOLARE:
	    _prezzo = new PrezzoRegolare();
	    break;
	case BAMBINI:
	    _prezzo = new PrezzoBambini();
	    break;
	case NOVITA:
	    _prezzo = new PrezzoNovita();
	    break;
	default:
	    throw new IllegalArgumentException("Codice prezzo scorretto");
	}
    }

    public String getTitolo() {
	return _titolo;
    }

    public double getAmmontare(int giorniNoleggio) {
	return _prezzo.getAmmontare(giorniNoleggio);
    }

    public int getPunteggioNoleggiFrequenti(int giorniNoleggio) {
	return _prezzo.getPunteggioNoleggiFrequenti(giorniNoleggio);
    }

}
