package videostore;
import java.util.*;

// 3.2
public class Cliente {
    private String _nome;
    private List _noleggi = new ArrayList();

    public Cliente (String nome) {
	_nome = nome;
    }

    public void addNoleggio(Noleggio arg) {
	_noleggi.add(arg);
    }
    
    public String getNome(){
	return _nome;
    }

    public String rendiconto() {
	double ammontareTotale = 0;
	int puntiNoleggiFrequenti = 0;
	Iterator noleggi = _noleggi.iterator();
	String r = "Rendiconto noleggi per " + getNome() + "\n";
	while (noleggi.hasNext()) {
	    double questoAmmontare = 0;
	    Noleggio ognuno = (Noleggio) noleggi.next();
	    
	    questoAmmontare = ammontarePer(ognuno);

	    // punti per noleggi frequenti
	    puntiNoleggiFrequenti++;

	    // bonus per noleggi novita' di 2 giorni
	    if ((ognuno.getFilm().getCodicePrezzo() == Film.NOVITA) &&
		ognuno.getGiorniNoleggio() > 1)
		puntiNoleggiFrequenti++;

	    // aggiungi al risultato
	    r += "\t" + ognuno.getFilm().getTitolo() + "\t" + 
		 String.valueOf(questoAmmontare) + "\n";
	    ammontareTotale += questoAmmontare;
	} // while

	// aggiungi pie' di pagina
	r += "L'ammontare dovuto e' " + String.valueOf(ammontareTotale) + "\n";
	r += "Hai guadagnato " + String.valueOf(puntiNoleggiFrequenti) + " punti per noleggi frequenti\n";
	return r;
    }

    private double ammontarePer(Noleggio unNoleggio) {
	double risultato = 0;
	// ammontare per ogni noleggio
	switch (unNoleggio.getFilm().getCodicePrezzo()) {
	case Film.REGOLARE:
	    risultato += 2;
	    if (unNoleggio.getGiorniNoleggio() > 2)
		risultato += (unNoleggio.getGiorniNoleggio() - 2) * 1.5;
	    break;
	case Film.NOVITA:
	    risultato += unNoleggio.getGiorniNoleggio() * 3;
	    break;
	case Film.BAMBINI:
	    risultato += 1.5;
	    if (unNoleggio.getGiorniNoleggio() > 3)
		risultato += (unNoleggio.getGiorniNoleggio() - 3) * 1.5;
	    break;
	}
	return risultato;
    }
}
